import guru.ttslib.*;

TTS tts;

// Sample sur texte
// Ce script permet de charge des sample en aiff ou mp3 
// et un texte sous forme brute (txt)
// d'analyse le texte 
// en connaitre le nombre de mots, de phrases, 
// savoir combien de fois chaque mot est utilisé
// et passer en revue le texte mot par mot 
// ou phrase par phrase
// et de déclencher des sons en fonction d'un test.
texte montexte;


// donner le nom des éléments à charger
String s="madame_bovary.txt"; // nom du texte

void setup() {
  size(600, 600);
  // charger les fichiers mp3 ou aif dans "liste"
tts = new TTS();
  montexte=new texte(s);


  // quelques infos sur le texte analysé
  println("Dans le texte "+s);
  println("nombre de mots: "+montexte.nombre_mots);
  println("nombre de phrases: "+montexte.nombre_phrases);
  println("nombre de mots dans l'inventaire : "+montexte.inventaire.size());
  println("Mot le plus employé : -"+montexte.tri_mot[0]+"- "+montexte.tri_occurence[0]+ " fois");
}

void draw() {
  background(0);
  fill(255);

  //montexte.mot_suivant();
  montexte.phrase_suivante();
  String p=montexte.phrase;
String m=quelsmots(p, "Bovary|madame|femme|corps|robe|vetement|manches|regret|courage|peur|joie|gaieté|énergie|tristesse|colère");
  if (m !="") {
    fill(0, 255, 100);
    rect(0, 0, width*0.2, height);
    println(m);
    tts.speak(m);
    
  }
/*
  if (combien(p, "Bovary|campagne|terre|champ|vache|porc|rivière|boue|regret|courage|peur|joie|gaieté|énergie|tristesse|colère") > 0) {
    fill(255, 0, 0);
    rect(width*0.2, 0, width*0.2, height);
  }

  if (combien(p, "maison|route|voiture|ville|chapeau|papier|soulier") > 0) {
    fill(0, 255, 0);
  }

  if (combien(p, "bovary") > 0) {
    fill(0, 0, 255);
  }
  
  if (combien(p, "regret|courage|peur|joie|gaieté|énergie|tristesse|colère") > 0) {
    fill(100, 0, 255);
  }
*/
  fill(255);
  affiche_stats();
  delay(100);
}